/**********************************************************************
 *** fichier principal pour le TP3 d'info-614 : RC4, WEP et attaque   *
 *** FMS                                                              *
 *** C'est ce fichier qui contient la fonction "predit_octet"         *
 *** Nom : Tartempion                                                 *
 *** Prénom : Lucien                                                  *
 *** filière : L3-cirque, specialité domptage                         *
 **********************************************************************/

#include "tp3.h"

/* pour controler un peu l'affichage */
int verbose = 0;



/**********************************************************************
 * devine le "n"-ième octet de la clé (en supposant qu'on connait les *
 * n-1 octets précédents) en essayant tous les vecteurs               *
 * d'initialisations faibles.                                         *
 * L'argument "cle_wep_partielle" contient le début de la clé (octets *
 * 0 à "n"-1, non compris).                                           *
 * La fonction ne modifie pas les "n"-1 premieres valeurs de          *
 * "cle_wep_partielle".                                               *
 *                                                                    *
 * L'argument "nb_IV_faibles" est le nombre de vecteurs faibles à     *
 * considérer.                                                        *
 * L'argument "nb_IV_total" est le nombre total de vecteurs à tester. *
 *                                                                    *
 * La fonction s'arrete quand l'une des deux bornes est atteinte.     *
 *                                                                    *
 * Si les 2 bornes sont nulles, on utilise alors uniquement la        *
 * famille de vecteurs (n+3, 255, ...). ATTENTION, ca n'est possible  *
 * que si "taille_IV = 3".                                            *
 *                                                                    *
 * La fonction renvoie "n" si l'opération c'est bien passée. Dans ce  *
 * cas, l'octet "n"-1 de "cle_wep_partielle" est positionné à sa      *
 * valeur.                                                            *
 *                                                                    *
 * La fonction renvoie "-1" en cas de problème. La "n"-ieme valeur de *
 * "cle_wep_partielle" est alors quelconque.                          *
 **********************************************************************/
int predit_octet(int n, octet *cle_wep_partielle, int nb_IV_faibles, int nb_IV_total)
{

  /* À FAIRE... */
  int rien = n + cle_wep_partielle[0] + nb_IV_faibles + nb_IV_total;


  return (rien-1-rien);
}
